#include "KMotionDef.h"
double nextFlip = 0, T, Tfro, Potfro, FRO, Pot, SRO, LastSRO, LastSROTime, SRO1, LastFRO, LastFROTime, FRO1;
#define CHANGE_TOL 0.2
#define CHANGE_TIME 0.2
int result;
int clast=0,clastsolid=-1,ccount=0;
int flast=0,flastsolid=-1,fcount=0;
int flash = 1;

ServiceTower()
{
	// Handle feedhold
	if (CS0_StoppingState > 0) {
		SetBit(TOWERAMB);
		SetBit(FHLED);
	} else {
		ClearBit(TOWERAMB);
		ClearBit(FHLED);
	}
	// Handle EStop
	if(!ReadBit(SYSTEMOK))		// are we in e-stop?
	{
		//SetBit(TOWERRED);
		
		if(nextFlip < Time_sec() && flash == 0){
			SetBit(TOWERRED);
			flash = 1;
			nextFlip = Time_sec() + 1;
		} else if (nextFlip < Time_sec() && flash == 1){
			ClearBit(TOWERRED);
			flash = 0;
			nextFlip = Time_sec() + 1;
		}
	} else {
		ClearBit(TOWERRED);
		// we want solid red if end of program and not in e-stop
	}
	if(JOB_ACTIVE){
		SetBit(TOWERGRN);
		SetBit(CSLED);
	} else {
		ClearBit(TOWERGRN);
		ClearBit(CSLED);
	}
	
}

ServiceButtons()
{
	result = Debounce(ReadBit(CSBUTTON),&ccount,&clast,&clastsolid);
	if(result == 1){
		DoPC(PC_COMM_EXECUTE);
	}
	result = Debounce(ReadBit(FHBUTTON),&fcount, &flast, &flastsolid);
	if(result == 1){
		if (CS0_StoppingState == 0)
			StopCoordinatedMotion();
		else
			ResumeCoordinatedMotion();
	}
}

ServicePots()
{
	T = Time_sec();
	Tfro = T;
	
	// assume 10V range where 5V is nominal FRO
	Potfro=KANALOG_CONVERT_ADC_TO_VOLTS(ADC(ADCSSO)) - 4.0;
	
	FRO = Potfro*0.25 + .6;
	
	// assume 10V range where 5V is nominal FRO
	Pot=KANALOG_CONVERT_ADC_TO_VOLTS(ADC(ADCFRO)) - 4.5;
	
	SRO = Pot*0.25 + .65;
	
	
	// send message to KMotionCNC if the pot changed significantly
	// and it has been a while since the last message
	if ((SRO > LastSRO+CHANGE_TOL || SRO < LastSRO-CHANGE_TOL) && 
		T > LastSROTime+CHANGE_TIME)
	{
		if (SRO>.7 && SRO<1.) SRO1=1;
		else
		{
			if (SRO<.7) SRO1 = SRO+.3;
			else
			{
				SRO1=SRO;
			}
		}
		if (SRO1<0) SRO1 = 0.01;
		DoPCFloat(PC_COMM_SET_SSO,SRO1);
		float speed = *(float *)&persist.UserData[SPDLKMVAR];
		if ((speed * SPDLFACTOR ) >444444.3) speed = 10000;
		printf("speed = %f\n",speed);
		printf("SRO = %f\n",SRO1);
		if (ReadBit(47) == 1 && SRO1 == .01) Jog(3,0);
		else
		{
		Jog(3,speed * SPDLFACTOR * -1);
	    }
		if (ReadBit(46) == 1 && SRO1 == .01) Jog(3,0);
		else
		{
		Jog(3,speed * SPDLFACTOR );
	    }
			LastSRO=SRO;
		LastSROTime=T;
	}
	// send message to KMotionCNC if the pot changed significantly
	// and it has been a while since the last message
	if ((FRO > LastFRO+CHANGE_TOL || FRO < LastFRO-CHANGE_TOL) && 
		Tfro > LastFROTime+CHANGE_TIME)
	{		
		if (FRO>.7 && FRO<1.) FRO1=1;
		else
		{
			if (FRO<.7) FRO1 = FRO+.3;
			else
			{
				FRO1=FRO;
			}
		}
		DoPCFloat(PC_COMM_SET_FRO,FRO1);
			
		LastFRO=FRO;
		LastFROTime=Tfro;
	}
}

#define DBTIME 300

int Debounce(int n, int *cnt, int *last, int *lastsolid)
{
	int v = -1;
	
	if (n == *last)  // same as last time?
	{
		if (*cnt == DBTIME-1)
		{
			if (n != *lastsolid)
			{
				v = *lastsolid = n;  // return debounced value
			}
		}
		if (*cnt < DBTIME)	(*cnt)++;
	}
	else
	{
		*cnt = 0;  // reset count
	}
	*last = n;
	return v;
}
