#include "KMotionDef.h"
#include "Triac.h"
#include "KflopToKMotionCNCFunctions.c"

// this function checks everything is fully initialised and ready to run parts, otherwise it commands a halt and warns user
// Checks include Homed, TC initialised
main()
{
	if(!ReadBit(XHOMED))	// if X axis is not homed, we can't start
	{
		DoPC(PC_COMM_HALT);	// we'll tell KMotionCNC to Halt
		MsgBox("Cycle Start inhibited - X Axis not homed",MB_OK|MB_ICONEXCLAMATION);
	}
	if(!ReadBit(YHOMED))	// if Y axis is not homed, we can't start
	{
		DoPC(PC_COMM_HALT);	// we'll tell KMotionCNC to Halt
		MsgBox("Cycle Start inhibited - Y Axis not homed",MB_OK|MB_ICONEXCLAMATION);
	}
	if(!ReadBit(ZHOMED))	// if Z axis is not homed, we can't start
	{
		DoPC(PC_COMM_HALT);	// we'll tell KMotionCNC to Halt
		MsgBox("Cycle Start inhibited - Z Axis not homed",MB_OK|MB_ICONEXCLAMATION);
	}
	if(!ReadBit(TCINIT))	// if TCINIT is not set, the TC is not ready
	{
		DoPC(PC_COMM_HALT);	// we'll tell KMotionCNC to Halt
		MsgBox("Cycle Start inhibited - ToolChanger not initialised",MB_YESNO|MB_ICONEXCLAMATION);
	}
}
