#include "KMotionDef.h"
#include "Triac.h"

// desired speed is passed from KMotionCNC in variable KMVAR
// save in user variable STATEVAR whether it was off, CW, or CCW (0,1,-1)
// save in user variable SPEEDVAR the last desired speed

main()
{
	float speed = *(float *)&persist.UserData[SPDLKMVAR];  // value stored is actually a float 
	float LastState = persist.UserData[SPDLSTATE];  // get last state 
	
	persist.UserData[SPDLSPEED] = persist.UserData[SPDLKMVAR];  // Always save the last desired speed 
	
	if (LastState==0)  
	{
		// if spindle is off and User Changes the speed 
		// just save the desired speed
		
		return 0;
	}
	
	// spindle is already on, so ramp to new speed
	if(LastState == 1) {	// if CW we jog negatively
		Jog(SPINDLE,speed * SPDLFACTOR);
		printf("Jogging CW Spindle %f counts/sec\n",speed * SPDLFACTOR);
	} else {	// else we're going CCW so jog positively
		Jog(SPINDLE,speed * SPDLFACTOR * -1);
		printf("Jogging CCW Spindle %f counts/sec\n",speed * SPDLFACTOR * -1);
	}
}
