#include "KMotionDef.h"
#include "Triac.h"
#include "KflopToKMotionCNCFunctions.c"
#include "TriacSpindle.c"

// desired speed is passed from KMotionCNC in variable KMVAR
// save in user variable STATEVAR whether it was off, CW, or CCW (0,1,-1)
// save in user variable SPEEDVAR the last desired speed

main()
{
	float speed = *(float *)&persist.UserData[SPDLSPEED];  // value stored is actually a float 
	float LastState = persist.UserData[SPDLSTATE];  // get last state 
	
	SpindleTest();	// call function to check spindle is out of fault, and attempt reset if needed
	// if spindle was Off, we need to enable axis 
	if (LastState==0)  
	{
		// basic sanity check to make sure toolchanger is out and up, and drawbar is no active
		if(!ReadBit(CRSLOUT) || !ReadBit(CRSLUP) || ReadBit(DRBR)) {
			// activate feedhold
			MsgBoxNoWait("Toolchanger not Up and out, or Drawbar still active",MB_OK|MB_ICONEXCLAMATION);
		} else { // else we're ok to enable spindle
			SetBit(SPDLENA);
			Delay_sec(0.3);		// delay to avoid PID windup due to servo drive taking time to enable
			EnableAxisDest(7, ch7->Position);
		}
	}
	
	// spindle is already on, so ramp to new speed
	Jog(SPINDLE,speed * SPDLFACTOR * -1);
	printf("Jogging CCW Spindle %f counts/sec\n",speed * SPDLFACTOR * -1);

	persist.UserData[SPDLSTATE] = -1;  // remember we are On
}

